Package org.codehaus.groovy.control

# Class PlaceholderVisitor

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.codehaus.groovy.ast.ClassCodeVisitorSupport
org.codehaus.groovy.control.PlaceholderVisitor

All Implemented Interfaces:
  `GroovyClassVisitor`, `GroovyCodeVisitor`, `ErrorCollecting`

public class PlaceholderVisitor extends ClassCodeVisitorSupport
Marks repeated underscore placeholders used in tuple and closure parameters.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PlaceholderVisitor(CompilationUnit compilationUnit, SourceUnit source)`
  Creates a visitor for placeholder analysis.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected SourceUnit`
  `getSourceUnit()`
  Returns the source unit currently being visited.
  `static boolean`
  `isPlaceholder(ASTNode node)`
  Checks whether the supplied node has been marked as a placeholder.
  `void`
  `visitClosureExpression(ClosureExpression expression)`
  Visit the Closure (or Lambda) marking underscore-named parameters as placeholders
  `void`
  `visitDeclarationExpression(DeclarationExpression expression)`
  Visit the declaration marking underscore-named variables in multi-assignments as placeholders

  ### Methods inherited from class org.codehaus.groovy.ast.ClassCodeVisitorSupport

  `addError, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBooleanExpression, visitBytecodeExpression, visitCastExpression, visitClassExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitEmptyStatement, visitFieldExpression, visitGStringExpression, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitTernaryExpression, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

- ## Constructor Details

  - ### PlaceholderVisitor

    public PlaceholderVisitor(CompilationUnit compilationUnit, SourceUnit source)
    Creates a visitor for placeholder analysis.
    Parameters:
      `compilationUnit` - the owning compilation unit
      `source` - the source unit being visited

- ## Method Details

  - ### getSourceUnit

    protected SourceUnit getSourceUnit()
    Returns the source unit currently being visited.
    Specified by:
      `getSourceUnit` in class `ClassCodeVisitorSupport`
    Returns:
      the active source unit

  - ### visitDeclarationExpression

    public void visitDeclarationExpression(DeclarationExpression expression)
    Visit the declaration marking underscore-named variables in multi-assignments as placeholders
    Specified by:
      `visitDeclarationExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitDeclarationExpression` in class `ClassCodeVisitorSupport`
    Parameters:
      `expression` - the expression to check

  - ### visitClosureExpression

    public void visitClosureExpression(ClosureExpression expression)
    Visit the Closure (or Lambda) marking underscore-named parameters as placeholders
    Specified by:
      `visitClosureExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitClosureExpression` in class `ClassCodeVisitorSupport`
    Parameters:
      `expression` - the expression to check

  - ### isPlaceholder

    public static boolean isPlaceholder(ASTNode node)
    Checks whether the supplied node has been marked as a placeholder.
    Parameters:
      `node` - the node to inspect
    Returns:
      `true` if the node is a placeholder